#define __AVR_ATmega128_    (1)     // device select: _ATMEGAxxxx
#define	_B1024	            (1)     // boot size select: _Bxxx (words) 512,1024,2048,4096
                                    // if this changes then  LDFLAGS += -Wl,-Ttext=0x1f800
                                    // in makefile must change accordingly            ^^
    
#define FALSE               (0)
#define TRUE                (1)
	
#define	DEVTYPE             (0x43)      // mega128 supported device code for avrprog
#define	SIGNATURE_BYTE_1    (0x1E)
#define	SIGNATURE_BYTE_2    (0x97)
#define	SIGNATURE_BYTE_3    (0x02)
#define MARKER_WORD         (0xA55A)       
#define PAGESIZEBYTES       (256)               //Size in Bytes (this is mega128 specific)
#define PAGESIZEWORDS       (PAGESIZEBYTES/2)   //Size in words
                                                    
#ifdef _B512
    #define APP_PAGES       (512L-4)     // use LDFLAGS += -Wl,-Ttext=0x1fc00 in makefile
    #define BOOTJMP          __asm__("jmp 0x1fc00");
    // bootloader starts at word address $FE00,  in Fuse High Byte BOOTSZ1 = 1, BOOTSZ0 = 1
#endif
#ifdef _B1024
    #define APP_PAGES       (512L-8)     // use LDFLAGS += -Wl,-Ttext=0x1f800 in makefile
    #define BOOTJMP          __asm__("jmp 0x1f800");
    // bootloader starts at word address $FC00,  in Fuse High Byte BOOTSZ1 = 1, BOOTSZ0 = 0
#endif
#ifdef _B2048
    #define APP_PAGES       (512L-16)    // use LDFLAGS += -Wl,-Ttext=0x1f000 in makefile
    #define BOOTJMP          __asm__("jmp 0x1f000");
    // bootloader starts at word address $F800,  in Fuse High Byte BOOTSZ1 = 0, BOOTSZ0 = 1
#endif
#ifdef _B4096
    #define APP_PAGES       (512L-32)    // use LDFLAGS += -Wl,-Ttext=0x1e000 in makefile
    #define BOOTJMP          __asm__("jmp 0x1e000");
    // bootloader starts at word address $F000,  in Fuse High Byte BOOTSZ1 = 0, BOOTSZ0 = 0
#endif                 //     ^
//               mega128 has 512 pages total                     
// 
#define LAST_APP_BYTE       ((APP_PAGES * PAGESIZEBYTES)-1)  
#define LAST_APP_WORD       ((LAST_APP_BYTE-1)/2)


